"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Prognosis(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "referenceUrl",
        "variantActionable",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import reports as reports_6_7_1

        return {
            "prognosis": reports_6_7_1.PrognosisClassification,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_2 import reports as reports_6_7_1

        return {
            "org.gel.models.report.avro.PrognosisClassification": reports_6_7_1.PrognosisClassification,
            "org.gel.models.report.avro.Prognosis": reports_6_7_1.Prognosis,
        }

    __slots__ = [
        "referenceUrl",
        "variantActionable",
        "conditions",
        "description",
        "prognosis",
        "references",
        "source",
    ]

    def __init__(
        self,
        referenceUrl,
        variantActionable,
        conditions=None,
        description=None,
        prognosis=None,
        references=None,
        source=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_6_7_1.Prognosis model.

        :param referenceUrl:
            URL where reference information for this prognosis can be found
        :type referenceUrl: str
        :param variantActionable:
            If true, the association was made at the variant level, if not the
            association was made at Genomic Entity level
        :type variantActionable: boolean
        :param conditions:
            Conditions
        :type conditions: None | list[str]
        :param description:
            Full description of the associated prognosis
        :type description: None | str
        :param prognosis:
            Prognosis classification (defined as favourable or unfavourable), in
            the case that the direction of the prognosis is not known
            altered_prognosis should be used
        :type prognosis: None | PrognosisClassification
        :param references:
            References
        :type references: None | list[str]
        :param source:
            Source if known
        :type source: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "6.7.1"
